module MassdebatorApi
  class Service < ActiveResource::Base
    mattr_accessor :config_hash

    def self.base_path
      "/api/v1"
    end

    def self.base_uri
      "http://#{self.host}#{self.base_path}"
    end

    def self.configuration_hash
      if Rails.root
        @@config_hash ||= YAML.load_file("#{Rails.root}/config/massdebator.yml")
      else
        @@config_hash ||= YAML.load_file("config/massdebator.yml")
      end
    end

    def self.host
      self.configuration_hash[Rails.env]['host']
    end

    def self.token
      self.configuration_hash[Rails.env]['token']
    end

    def self.secret
      self.configuration_hash[Rails.env]['secret']
    end

    def self.port
      self.configuration_hash[Rails.env]['port']
    end

    self.site = self.base_uri
    MassdebatorApi::Service.headers['massdebator-token'] = token
    MassdebatorApi::Service.headers['massdebator-secret'] = secret
    self.format = :json

    class << self
      # If headers are not defined in a given subclass, then obtain
      # headers from the superclass.
      def headers
        if defined?(@headers)
          @headers
        elsif superclass != Object && superclass.headers
          superclass.headers
        end
      end
    end

  #  private
  #
  #  def self.get(path, options = {})
  #    response = request(:get, path, options)
  #    JSON.parse(response.body)
  #  rescue JSON::JSONError
  #    {}
  #  end
  #
  #  def self.post(path, options = {})
  #    request(:post, path, options)
  #  end
  #
  #  def self.put(path, options = {})
  #    request(:put, path, options)
  #  end
  #
  #  def self.delete(path, options = {})
  #    request(:delete, path, options)
  #  end
  #
  #  def self.post_with_response(*args)
  #    response = post(*args)
  #    JSON.parse(response.body)
  #  rescue JSON::JSONError
  #    {}
  #  end
  #
  #  def self.put_with_response(*args)
  #    response = put(*args)
  #    JSON.parse(response.body)
  #  rescue JSON::JSONError
  #    {}
  #  end
  #
  #  def self.request(http_verb, path, options = {})
  #    verb_type = case http_verb.to_sym
  #                when :get    then Net::HTTP::Get
  #                when :post   then Net::HTTP::Post
  #                when :put    then Net::HTTP::Put
  #                when :delete then Net::HTTP::Delete
  #                end
  #
  #    request_path = "#{self.base_path}#{path}"
  #    request_body = nil
  #
  #    if verb_type == Net::HTTP::Get
  #      query = options.to_query
  #      request_path += "?#{query}" if query.present?
  #    else
  #      request_body = options.to_json
  #    end
  #
  #    response = Net::HTTP.start(self.host, self.port || 80) do |http|
  #      http_req = verb_type.new(request_path)
  #
  #      http_req.add_field "Content-Length", request_body.size if request_body
  #      http_req.add_field "Content-Type", "application/json"
  #      http_req.add_field "massdebator-token", self.token
  #      http_req.add_field "massdebator-secret", self.secret
  #
  #      http.request(http_req, request_body)
  #    end
  #
  #    if [Net::HTTPClientError, Net::HTTPServerError].any? {|resp| response.is_a?(resp) }
  #      message = %{Error communicating with Massdebator (#{response.code}): #{request_path}}
  #      exception = Net::HTTPBadResponse.new(message)
  #      raise exception
  #    end
  #
  #    response
  #  end
  end
end
